regina::SpiralSolidTorus Class Reference
Standard Triangulations and Subcomplexes

Represents a spiralled solid torus in a triangulation. More...

`#include <subcomplex/spiralsolidtorus.h>`

Inheritance diagram for regina::SpiralSolidTorus:

## Public Member Functions

virtual | ~SpiralSolidTorus ()
| Destroys this spiralled solid torus. More...
SpiralSolidTorus * | clone () const
| Returns a newly created clone of this structure. More...
size_t | size () const
| Returns the number of tetrahedra in this spiralled solid torus. More...
Tetrahedron< 3 > * | tetrahedron (size_t index) const
| Returns the requested tetrahedron in this spiralled solid torus. More...
Perm< 4 > | vertexRoles (size_t index) const
| Returns a permutation represeting the role that each vertex of the requested tetrahedron plays in the solid torus. More...
void | reverse ()
| Reverses this spiralled solid torus. More...
void | cycle (size_t k)
| Cycles this spiralled solid torus by the given number of tetrahedra. More...
bool | makeCanonical (const Triangulation< 3 > *tri)
| Converts this spiralled solid torus into its canonical representation. More...
bool | isCanonical (const Triangulation< 3 > *tri) const
| Determines whether this spiralled solid torus is in canonical form. More...
Manifold * | manifold () const
| Returns the 3-manifold represented by this triangulation, if such a recognition routine has been implemented. More...
AbelianGroup * | homology () const
| Returns the expected first homology group of this triangulation, if such a routine has been implemented. More...
std::ostream & | writeName (std::ostream &out) const
| Writes the name of this triangulation as a human-readable string to the given output stream. More...
std::ostream & | writeTeXName (std::ostream &out) const
| Writes the name of this triangulation in TeX format to the given output stream. More...
void | writeTextLong (std::ostream &out) const
| Writes a detailed text representation of this object to the given output stream. More...
std::string | name () const
| Returns the name of this specific triangulation as a human-readable string. More...
std::string | TeXName () const
| Returns the name of this specific triangulation in TeX format. More...
AbelianGroup * | homologyH1 () const
| Returns the expected first homology group of this triangulation, if such a routine has been implemented. More...
virtual void | writeTextShort (std::ostream &out) const
| Writes a short text representation of this object to the given output stream. More...
std::string | str () const
| Returns a short text representation of this object. More...
std::string | utf8 () const
| Returns a short text representation of this object using unicode characters. More...
std::string | detail () const
| Returns a detailed text representation of this object. More...

## Static Public Member Functions

static SpiralSolidTorus * | formsSpiralSolidTorus (Tetrahedron< 3 > *tet, Perm< 4 > useVertexRoles)
| Determines if the given tetrahedron forms part of a spiralled solid torus with its vertices playing the given roles in the solid torus. More...
static StandardTriangulation * | isStandardTriangulation (Component< 3 > *component)
| Determines whether the given component represents one of the standard triangulations understood by Regina. More...
static StandardTriangulation * | isStandardTriangulation (Triangulation< 3 > *tri)
| Determines whether the given triangulation represents one of the standard triangulations understood by Regina. More...

## Detailed Description

Represents a spiralled solid torus in a triangulation.

A spiralled solid torus is created by placing tetrahedra one upon another in a spiralling fashion to form a giant loop.

For each tetrahedron, label the vertices A, B, C and D. Draw the tetrahedron so that the vertices form an upward spiral in the order A-B-C-D, with D directly above A. Face BCD is on the top, face ABC is on the bottom and faces ABD and ACD are both vertical.

When joining two tetrahedra, face BCD of the lower tetrahedron will be joined to face ABC of the upper tetrahedron. In this way the tetrahedra are placed one upon another to form a giant loop (which is closed up by placing the bottommost tetrahedron above the topmost tetrahedron in a similar fashion), forming a solid torus overall.

In each tetrahedron, directed edges AB, BC and CD are major edges, directed edges AC and BD are minor edges and directed edge AD is an axis edge.

The major edges all combined form a single longitude of the solid torus. Using this directed longitude, using the directed meridinal curve ACBA and assuming the spiralled solid torus contains n tetrahedra, the minor edges all combined form a (2, n) curve and the axis edges all combined form a (3, n) curve on the torus boundary.

Note that all tetrahedra in the spiralled solid torus must be distinct and there must be at least one tetrahedron.

Note also that class TriSolidTorus represents a spiralled solid torus with precisely three tetrahedra. A spiralled solid torus with only one tetrahedron is in fact a (1,2,3) layered solid torus.

All optional StandardTriangulation routines are implemented for this class.

## Member Function Documentation

## detail()

std::string regina::Output< StandardTriangulation , false >::detail | ( |  | ) | const

inherited

Returns a detailed text representation of this object.

This text may span many lines, and should provide the user with all the information they could want. It should be human-readable, should not contain extremely long lines (which cause problems for users reading the output in a terminal), and should end with a final newline. There are no restrictions on the underlying character set.

Returns
  a detailed text representation of this object.

## str()

std::string regina::Output< StandardTriangulation , false >::str | ( |  | ) | const

inherited

Returns a short text representation of this object.

This text should be human-readable, should fit on a single line, and should not end with a newline. Where possible, it should use plain ASCII characters.

Python:\n In addition to str(), this is also used as the
  Python "stringification" function `__str__()`.

Returns
  a short text representation of this object.

## utf8()

std::string regina::Output< StandardTriangulation , false >::utf8 | ( |  | ) | const

inherited

Returns a short text representation of this object using unicode characters.

Like str(), this text should be human-readable, should fit on a single line, and should not end with a newline. In addition, it may use unicode characters to make the output more pleasant to read. This string will be encoded in UTF-8.

Returns
  a short text representation of this object.

The documentation for this class was generated from the following file:

- subcomplex/spiralsolidtorus.h

Copyright © 1999-2016, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@maths.uq.edu.au).